import base64
from socket import *

__author__ = 'jacobshutzman1'
""" Built client to match an SMTP server responses acording to the 
    analysis of 2 sniffed files: http://cyber.org.il/networks/c04/smtp1.pcap
                                 http://cyber.org.il/networks/c04/smtp2.pcap
"""

IP = '54.213.229.251'
PORT = 587
msg = "Yours Truly.\r\nJacob"
endmsg = "\r\n.\r\n"
server = (IP, PORT)
KBYTES = 1024


def get_code(response):
    """ gets received message, returns the code attached to it """
    return response[:3]


def hello(client_socket, resp):
    """ Initiating mail usage with hello hand-shake """
    print "Message after connection request:" + resp
    if get_code(resp) != '220':
        print('220 reply not received from server.')
    heloCommand = 'EHLO \r\n'
    client_socket.send(heloCommand)
    resp = client_socket.recv(KBYTES)
    print("Message after EHLO command:" + resp)
    if get_code(resp) != '250':
        print('250 reply not received from server.')


def authorize(client_socket):
    """ encoding username + password and sending for authorization """
    username = "js3104@nyu.edu"
    password = "password1!"
    base64_str = "\x00" + username + "\x00" + password
    usrpass_encoded = base64.b64encode(base64_str)
    authMsg = "AUTH PLAIN " + usrpass_encoded + "\r\n"
    client_socket.send(authMsg)
    recv_auth = client_socket.recv(KBYTES)
    print(recv_auth)


def mail_fields(client_socket):
    """ preparing and sending addressee and addressed participants """
    mailFrom = "MAIL FROM:<js4104@nyu.edu>\r\n"
    client_socket.send(mailFrom)
    resp = client_socket.recv(KBYTES)
    print "After MAIL FROM command: " + resp
    rcptTo = "RCPT TO:jacob.shutzman@nyu.edu\r\n"
    client_socket.send(rcptTo)
    resp = client_socket.recv(KBYTES)
    print "After RCPT TO command: " + resp


def data_items(client_socket):
    """ Building and sending the email data """
    data = "DATA\r\n"
    client_socket.send(data)
    resp = client_socket.recv(KBYTES)
    print "After DATA command: " + resp
    subject = "Subject: test old protocol\r\n\r\n"
    message = subject + msg + endmsg
    client_socket.send(message)
    recv_msg = client_socket.recv(KBYTES)
    if get_code(recv_msg) != '250':
        print('end msg 250 reply not received from server.')
    print "Response after sending message body:" + recv_msg
    quit = "QUIT\r\n"
    client_socket.send(quit)


def main():
    client_socket = socket(AF_INET, SOCK_STREAM)
    client_socket.connect(server)
    resp = client_socket.recv(KBYTES)
    hello(client_socket, resp)
    authorize(client_socket)
    mail_fields(client_socket)
    data_items(client_socket)
    resp = client_socket.recv(KBYTES)
    print(resp)
    client_socket.close()

if __name__ == '__main__':
    main()
