__author__ = 'jacob shutzman'
import re
import sys
import time
i, o, e = sys.stdin, sys.stdout, sys.stderr
from scapy.all import *
sys.stdin, sys.stdout, sys.stderr = i, o, e

"""
   Usege:  my_nslookup url
   Implementation of nslookup (A) with scapy. Finding the IP address of a URL.
   A timeout of 2 seconds was added, for url's that do not respond.
"""
GOOGLE_DNS_IP = '8.8.8.8'
DNS_STANDARD_PORT = 53
CHOSEN_PORT = 24601

def extract_ip(search_str):
    """ gets a string with summary data including an IP address.
        Extracts and returns the IP address only with a regular expression
    """
    ip_candidates = \
        re.findall(r"\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b", search_str)
    if len(ip_candidates) == 1:
        return ip_candidates[0]
    else:
        return None


def main():
    if len(sys.argv) != 2:
        print "Usage is: my_nslookup.py  url"
    else:
        arg1 = sys.argv[1]
        dns_packet = IP(dst=GOOGLE_DNS_IP) / UDP(sport=CHOSEN_PORT,
            dport=DNS_STANDARD_PORT) \
            / DNS(qdcount=1, rd=1) / DNSQR(qname=arg1)
        start_sending = time.time()
        response_packet = sr1(dns_packet, timeout=2)
        end_sending = time.time()
        time_for_query = end_sending - start_sending # processing time
        # Now check which of the DSN responses has the IP if any
        dns_part = response_packet['DNS']
        potential_ip = ''
        found = False
        i = 0
        while not found and i < (dns_part.ancount):
            dnsrr = dns_part.an[i]
            potential_ip = extract_ip(str(dnsrr.rdata))
            if potential_ip:
                print 'ip: ', potential_ip, '\t', time_for_query, ' seconds'
                found = True
            i += 1
        if not found:
            print 'unavailable in time: ', time_for_query

if __name__ == '__main__':
    main()